void callmqtt(const char* probe,float probeval)
{
  snprintf(msg,MSG_BUFFER_SIZE, String(probeval,2).c_str());  //Convert message to char
  mqttClient.publish(probe,msg,true);  //Send to broker
  //Serial.println(probe + String(probeval,2));
  Serial.println(msg);
}
void setupWifi()
{
  Serial.println("Connection to: " + String(STASSID));
  WiFi.mode(WIFI_STA);
  WiFi.begin(STASSID, STAPSK);
  while (WiFi.status() != WL_CONNECTED)
    {
     Serial.print(".");
     delay(500);
     lp++;
     if(lp >= 60){ break;  }
     } 
  Serial.println("");
  Serial.println("WiFi connected");
  Serial.print("IP address: "); Serial.println(WiFi.localIP());
}
void reconnectMQTT()
{
  while(!mqttClient.connected())
  {
    Serial.println("Login to MQTT-Broker");
    if(mqttClient.connect(clientID.c_str(), MQTTUSER, MQTTPASS))
    {
      Serial.println("Connected to MQTT-Broker " +String(MQTT_BROKER));
    }
    else
    {
      Serial.println("Failed with rc=" +String(mqttClient.state()));
      Serial.println("Next MQTT-Connect in 3 sec");
      delay(3000);
    }
  }
}
void SendHttp (String url)
{
    Serial.println(url);
    WiFiClient client;

    HTTPClient http;

    Serial.println("[HTTP] begin...  ");
    // send HTTP 
    if (http.begin(client, url)) 
      {  
      // start connection and send HTTP header
      int httpCode = http.GET();
      // httpCode will be negative on error
      if (httpCode > 0) 
        {
        // HTTP header has been send and Server response header has been handled
        Serial.println(String(httpCode));
        // file found at server
        if (httpCode == HTTP_CODE_OK || httpCode == HTTP_CODE_MOVED_PERMANENTLY) 
        {
          HttpReturnString = http.getString();
          Serial.println(HttpReturnString);
        }
        } else 
        {
          Serial.print("[HTTP] GET... failed, error: %s\n"); Serial.println( http.errorToString(httpCode).c_str());
        }
      http.end();
     } else {
      Serial.println("[HTTP} Unable to connect\n");
    } 
}
void TestCurrentTime() 
  {
  // read current time  from internet    
  SendHttp (TimeHttp);
  int indx01 = HttpReturnString.indexOf("datetime") + 22;
  String CurrentTimeString = HttpReturnString.substring(indx01,indx01 + 2) + HttpReturnString.substring(indx01 + 3, indx01 + 5) + HttpReturnString.substring(indx01 + 6, indx01 + 8);
//  float CurrentTimeFloat = CurrentTimeString.toFloat(); 
  CurrentTimeString.toCharArray(msg, MSG_BUFFER_SIZE);
  mqttClient.publish(ProbeTimeOne,msg,true);  //Send to broker
  indx01 = HttpReturnString.indexOf("datetime") + 11;
  String CurrentDateString = HttpReturnString.substring(indx01,indx01 + 4) + HttpReturnString.substring(indx01 + 5, indx01 + 7) + HttpReturnString.substring(indx01 + 8, indx01 + 10);
  CurrentDateString.toCharArray(msg, MSG_BUFFER_SIZE);
  mqttClient.publish(ProbeDate,msg,true);  //Send to broker
}
void WriteCounter(int value)
{
    uint32_t storeValue = value;
    ESP.rtcUserMemoryWrite(0, &storeValue, 1);
}
int ReadCounter()
{
    uint32_t result;
    ESP.rtcUserMemoryRead(0, &result, 1);
    return (int)result;
}